# Class IconUIResource

java.lang.Object
javax.swing.plaf.IconUIResource

All Implemented Interfaces:
  `Serializable, Icon, UIResource`

public class IconUIResource extends Object implements Icon, UIResource, Serializable
An Icon wrapper class which implements UIResource. UI classes which set icon properties should use this class to wrap any icons specified as defaults. This class delegates all method invocations to the Icon "delegate" object specified at construction.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

See Also:
  - `UIResource`

## Constructor Summary

Constructors
Constructor
Description
`IconUIResource(Icon delegate)`
Creates a UIResource icon object which wraps an existing Icon instance.

## Method Summary

Modifier and Type
Method
Description
`int`
`getIconHeight()`
Returns the icon's height.
`int`
`getIconWidth()`
Returns the icon's width.
`void`
`paintIcon(Component c, Graphics g, int x, int y)`
Draw the icon at the specified location.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### IconUIResource

public IconUIResource(Icon delegate)
Creates a UIResource icon object which wraps an existing Icon instance.

Parameters:
  `delegate` - the icon being wrapped

## Method Details

### paintIcon

public void paintIcon(Component c, Graphics g, int x, int y)
Description copied from interface: `Icon`
Draw the icon at the specified location. Icon implementations may use the Component argument to get properties useful for painting, e.g. the foreground or background color.

Specified by:
  `paintIcon` in interface `Icon`
Parameters:
  `c` - a `Component` to get properties useful for painting
  `g` - the graphics context
  `x` - the X coordinate of the icon's top-left corner
  `y` - the Y coordinate of the icon's top-left corner

### getIconWidth

public int getIconWidth()
Description copied from interface: `Icon`
Returns the icon's width.

Specified by:
  `getIconWidth` in interface `Icon`
Returns:
  an int specifying the fixed width of the icon.

### getIconHeight

public int getIconHeight()
Description copied from interface: `Icon`
Returns the icon's height.

Specified by:
  `getIconHeight` in interface `Icon`
Returns:
  an int specifying the fixed height of the icon.